typedef enum {
	ILOAD_EDGE					= 21,
	LLOAD_EDGE					= 22,
	FLOAD_EDGE					= 23,
	DLOAD_EDGE					= 24,
	ALOAD_EDGE					= 25,

	ISTORE_EDGE					= 54,
	LSTORE_EDGE					= 55,
	FSTORE_EDGE					= 56,
	DSTORE_EDGE					= 57,
	ASTORE_EDGE					= 58,

	GET_STATIC_EDGE				= 178,
	PUT_STATIC_EDGE				= 179,
	GET_FIELD_EDGE				= 180,
	PUT_FIELD_EDGE				= 181,

	INVOKE_VIRTUAL_EDGE			= 182,
	INVOKE_SPECIAL_EDGE			= 183,
	INVOKE_STATIC_EDGE			= 184,
	INVOKE_INTERFACE_EDGE		= 185,
	MULTIANEWARRAY_EDGE			= 197,
	NEW_EDGE					= 187,
	ANEWARRAY_EDGE				= 189,
	CHECKCAST_EDGE				= 192,
	INSTANCEOF_EDGE				= 193,

	IINC_EDGE					= 132,
	JSR_EDGE					= 168,
	RET_EDGE					= 169,
	RET_W_EDGE					= 209,

	OVERRIDES_EDGE				= 256,
	IMPLEMENTS_METHOD_EDGE		= 257,
	EXTENDS_EDGE				= 258,
	IMPLEMENTS_INTERFACE_EDGE	= 259,
	INNER_EDGE					= 260,
	THROWS_EDGE					= 261,
	ARRAYOF_EDGE				= 262,
	INSTANTIATES_EDGE           = 263
} edgetypeE;

#define NUMBER_EDGE_TYPES		  264

class Cedge : public Cobject {
public:
	static Cedge *g_hash[HASHSIZE];

	Cedge			*m_hashP;
	int				m_lineno;
	Centity			*m_fromP;
	Centity			*m_toP;		/* Function->function or Function->variable */
	edgetypeE		m_code;
	unsigned int	m_freq;

	static u4T		hash(const Centity *fromP, const Centity *toP, u4T code);

	Cedge(Centity *fromP, Centity *toP, edgetypeE code, int lineno);

	static void		locate(Centity *fromP, Centity *toP, edgetypeE code, int lineno);
	void			resolve(void);

	const char *	get_type(void) const;

	virtual objectE	type(void) const;
	virtual void	emit_id(void) const;
	virtual void	emit_edges(void);
	virtual void	emit_attributes(void) const;
};
